import gmshpy, sys, time

geoFileName = "WhitSun.geo"
order = 3;
minJ = 0.5
minM = 0.25

g = gmshpy.GModel()
g.load(geoFileName)
g.mesh(2)

g.setOrderN(order, True, False)
mshFileName = "%s_p%i.msh" % (geoFileName[0:-4], order)
g.save(mshFileName)
g.setOrderN(order, False, False)
mshFileName = "%s_p%i_initial.msh" % (geoFileName[0:-4], order)
g.save(mshFileName)
OH = gmshpy.OptHomParameters()

OH.dim = 2
OH.onlyVisible = False
OH.BARRIER_MIN= minJ
OH.BARRIER_MAX = 100
OH.BARRIER_MIN_METRIC = minM
OH.nbLayers = 2
OH.distanceFactor = 1e12
OH.fixBndNodes = False
OH.weightFixed = 1e5
OH.weightFree = 1e2
OH.itMax = 20 
OH.optPassMax = 30
OH.strategy = 2

tic1 = time.time()
gmshpy.HighOrderMeshOptimizer(g, OH)
tic2 = time.time()

mshFileName = "%s_p%i_%.2g_%.2g.msh" % (geoFileName[0:-4], order, minJ, minM)
g.save(mshFileName)
print("%s %.3g" % (mshFileName, tic2 - tic1))
